import type { ComponentType, ReactElement } from "react";
import type { RenderOptions } from "@testing-library/react";
declare type Data<Props> = {
    [K in keyof Props]: Props[K] | ((arg: Props) => Props[K]);
};
export interface CreateRendererOptions<Props, ExtraProperties> {
    component: ComponentType<Props>;
    data?: ExtraProperties | (() => ExtraProperties);
    props?: Data<Props> | ((data: ExtraProperties) => Data<Props>);
    renderFunction: (ui: ReactElement, options?: RenderOptions) => any;
    wrapper?: RenderOptions["wrapper"];
}
export declare function createRenderer<Props = {}, ExtraProperties = {}>(options: CreateRendererOptions<Props, ExtraProperties>): (overrides?: Partial<((ExtraProperties | (() => ExtraProperties)) & (Data<Props> | ((data: ExtraProperties) => Data<Props>))) | undefined>) => Props & ExtraProperties & {
    renderUtils: any;
};
export {};
//# sourceMappingURL=create-renderer.d.ts.map