"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRenderer = void 0;
var React = __importStar(require("react"));
var function_1 = require("./utils/function");
var object_1 = require("./utils/object");
function createRenderer(options) {
    return function (overrides) {
        if (overrides === void 0) { overrides = {}; }
        var Component = options.component, _a = options.data, data = _a === void 0 ? {} : _a, _b = options.props, props = _b === void 0 ? {} : _b, renderFunction = options.renderFunction;
        var initialData = (0, function_1.runIfFn)(data);
        var dataWithOverrides = (0, object_1.overridePredefinedKeys)(initialData, overrides);
        var initialProps = (0, function_1.runIfFn)(props, dataWithOverrides);
        var propsWithOverrides = (0, object_1.overridePredefinedKeys)(initialProps, overrides);
        propsWithOverrides = (0, object_1.resolveObjValues)(propsWithOverrides);
        var renderUtils = renderFunction(React.createElement(Component, __assign({}, propsWithOverrides)), { wrapper: options.wrapper });
        return __assign(__assign(__assign({}, propsWithOverrides), dataWithOverrides), { renderUtils: renderUtils });
    };
}
exports.createRenderer = createRenderer;
//# sourceMappingURL=create-renderer.js.map